/*
 * kicker.h
 *
 *  Created on: 20.02.2014
 *      Author: AndreR
 */

#ifndef KICKER_H_
#define KICKER_H_

#include <stdint.h>

#include "util/event.h"

#define SPI1_ADC_SAMPLES 8

typedef struct _Kicker
{
	EventClient* pEventClient;
	uint16_t txData[SPI1_ADC_SAMPLES*2];
	union
	{
		uint16_t rxData[SPI1_ADC_SAMPLES*2];
		uint32_t rxData32[SPI1_ADC_SAMPLES];
	};

	float maxVoltage;
	float hystVoltage;

	float vCap;
	float iChg;

	uint8_t autoCharge;
	uint8_t state;

	uint8_t autoDischarge;

	float stress;
} Kicker;

extern Kicker kicker;

void KickerInit(EventManager* pEventManager);
void KickerSetMaxVoltage(float v);
void KickerSetVoltageHysteresis(float vHyst);
void KickerEnableCharge(uint8_t enable);
void KickerEnableAutoRecharge(uint8_t enable);
void KickerFire1(float duration);	// [s]
void KickerFire2(float duration);	// [s]
void KickerAutoDischarge();

#endif /* KICKER_H_ */
