/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "intercom_constants.h"
#include "hal/usart1.h"

Intercom intercom1;

static void txReady(void* pData)
{
	USART* pUSART = (USART*)pData;
	USARTStartTransfer(pUSART);
}

void Intercom1Init(EventManager* pEventManager)
{
	IntercomMedium medium;
	medium.pRxFifo = &usart1.rxFifo;
	medium.pTxFifo = &usart1.txFifo;
	medium.txReady = &txReady;
	medium.pTxReadyData = &usart1;
	medium.reachableAddresses = INTERCOM_ADDRESS_MAIN | INTERCOM_ADDRESS_MEDIA | INTERCOM_ADDRESS_RIGHT | INTERCOM_ADDRESS_LEFT;

	IntercomInit(&intercom1, INTERCOM_ADDRESS_KD, 0, pEventManager);

	usart1.callback = &IntercomRxReady;
	usart1.pUserData = &intercom1;
	IntercomAddMedium(&intercom1, medium);
}
