/*
 * supply.h
 *
 *  Created on: 28.01.2014
 *      Author: AndreR
 */

#ifndef SUPPLY_H_
#define SUPPLY_H_

#include "util/event.h"
#include "stm32f30x_dma.h"
#include "stm32f30x_adc.h"

#define NUM_DATA_SAMPLES 8
#define NUM_IR_SAMPLES 16

typedef void(*IRDoneCallback)();

typedef struct _Supply
{
	uint16_t adcData[2*NUM_DATA_SAMPLES];
	uint16_t irData[NUM_IR_SAMPLES];
	uint8_t irCur;
	uint16_t irResult[2];
	uint16_t batResult;
	uint16_t shuntResult;

	float bat;

	EventClient* pEventClient;

	uint32_t adcCalSupply;
	uint32_t adcCalIr;

	IRDoneCallback irDoneCb;

#ifdef DEBUG
	DMA_TypeDef* pDMA;
	DMA_Channel_TypeDef* pDMACh;
	ADC_TypeDef* pADC;
#endif
} Supply;

extern Supply supply;

void SupplyInit(EventManager* pEventManager);

#endif /* SUPPLY_H_ */
