/*
 * ctrl_motor.h
 *
 *  Created on: 08.03.2013
 *      Author: AndreR
 */

#ifndef CTRL_MOTOR_H_
#define CTRL_MOTOR_H_

#include "ctrl.h"

typedef struct _CtrlMotor
{
	float setpoint[4];
	arm_matrix_instance_f32 matSetpoint;

	uint32_t lastWakeTime;
	uint32_t lastStatusTime;
	uint32_t lastReaction[4];
	float curWheel[4];
	arm_matrix_instance_f32 matCurMotor;

	uint8_t logEnabled;
	uint8_t motorLog[4];
} CtrlMotor;

extern CtrlMotor ctrlMotor;
extern CtrlInstance ctrlMotorInstance;

void CtrlMotorSetTarget(float x, float y, float w);
void CtrlMotorSetMotorLog(uint8_t id, uint8_t enable);
void CtrlMotorSetLog(uint8_t enable);

#endif /* CTRL_MOTOR_H_ */
