/*
 * ctrl_vel.c
 *
 *  Created on: 08.03.2013
 *      Author: AndreR
 */

#include "ctrl_vel.h"

#include <string.h>

#include "util/console.h"
#include "motors.h"

#define REACTION_THRESHOLD 0.01f
#define STALL_TIMEOUT 5000

CtrlVel ctrlVel;

void CtrlVelInit()
{
	ctrlVel.matCurMotor.pData = ctrlVel.curMotor;
	ctrlVel.matCurMotor.numCols = 1;
	ctrlVel.matCurMotor.numRows = 4;

	ctrlVel.matCurXYW.pData = ctrlVel.curXYW;
	ctrlVel.matCurXYW.numCols = 1;
	ctrlVel.matCurXYW.numRows = 3;

	ctrlVel.matOutXYW.pData = ctrlVel.outXYW;
	ctrlVel.matOutXYW.numCols = 1;
	ctrlVel.matOutXYW.numRows = 3;

	ctrlVel.matOutMotor.pData = ctrlVel.outMotor;
	ctrlVel.matOutMotor.numCols = 1;
	ctrlVel.matOutMotor.numRows = 4;
}

void CtrlVelSetTarget(float x, float y, float w)
{
	ConsolePrint("New Vel: %hd %hd %hd\r\n", (int16_t)(x*1000.0f), (int16_t)(y*1000.0f), (int16_t)(w*1000.0f));

	ctrlVel.outXYW[0] = x;
	ctrlVel.outXYW[1] = y;
	ctrlVel.outXYW[2] = w;

	arm_mat_mult_f32(&ctrl.matXYW2Motor, &ctrlVel.matOutXYW, &ctrlVel.matOutMotor);

	// convert speed over ground to motor output
	for(uint8_t i = 0; i < 4; i++)
	{
		ctrlVel.outMotor[i] *= CTRL_WHEEL_TO_MOTOR_RATIO * 1/ctrl.botParams.wheelRadius * 1/(2*PI);
	}

	for(uint8_t i = 0; i < 4; i++)
		motors.mot[i].set.velocity = ctrlVel.outMotor[i];
}
