/*
 * buzzer.c
 *
 *  Created on: 23.12.2010
 *      Author: AndreR
 */

#include "buzzer.h"

#include "stm32f4xx_gpio.h"
#include "stm32f4xx_tim.h"
#include "stm32f4xx_rcc.h"
#include "misc.h"

#include "constants.h"

void BuzzerInit()
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);

	GPIO_InitTypeDef gpioInit;
	gpioInit.GPIO_Mode = GPIO_Mode_AF;
	gpioInit.GPIO_Speed = GPIO_Speed_50MHz;
	gpioInit.GPIO_Pin = GPIO_Pin_9;
	gpioInit.GPIO_OType = GPIO_OType_PP;
	gpioInit.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOA, &gpioInit);

	GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_TIM1);

	TIM_TimeBaseInitTypeDef timeBaseInit;
	timeBaseInit.TIM_Prescaler = 83;	// = 1MHz
	timeBaseInit.TIM_ClockDivision = 0;
	timeBaseInit.TIM_CounterMode = TIM_CounterMode_Up;
	timeBaseInit.TIM_Period = 320;
	timeBaseInit.TIM_RepetitionCounter = 0;
	TIM_TimeBaseInit(TIM1, &timeBaseInit);

	TIM_OCInitTypeDef ocInit;
	ocInit.TIM_OCIdleState = TIM_OCIdleState_Reset;
	ocInit.TIM_OCMode = TIM_OCMode_PWM2;
	ocInit.TIM_OCPolarity = TIM_OCPolarity_Low;
	ocInit.TIM_OutputState = TIM_OutputState_Enable;
	ocInit.TIM_Pulse = 160;
	TIM_OC2Init(TIM1, &ocInit);

	TIM_OC2PreloadConfig(TIM1, TIM_OCPreload_Enable);

	TIM_ARRPreloadConfig(TIM1, ENABLE);

	TIM_CtrlPWMOutputs(TIM1, ENABLE);

	BuzzerEnable(0);
}

void BuzzerEnable(uint8_t en)
{
	if(en)
		TIM_Cmd(TIM1, ENABLE);
	else
		TIM_Cmd(TIM1, DISABLE);
}
