/*
 * motors.h
 *
 *  Created on: 02.02.2014
 *      Author: AndreR
 */

#ifndef MOTORS_H_
#define MOTORS_H_

#include "ch.h"

#define MOTORS_EVENT_QUEUE_SIZE 5

#define MOT_FR 0
#define MOT_FL 1
#define MOT_RL 2
#define MOT_RR 3

typedef void(*MotorsUpdateCallback)(uint8_t);

typedef struct _Motors
{
	Mailbox eventQueue;
	msg_t eventQueueBuf[MOTORS_EVENT_QUEUE_SIZE];

	struct _mot
	{
		struct _set
		{
			float velocity;	// motor rounds per second
		} set;

		struct _cur
		{
			float velocity;	// motor rounds per second
		} cur;
	} mot[4];

	MotorsUpdateCallback updateCb;
} Motors;

extern Motors motors;

void MotorsInit();
msg_t MotorsTask(void* params);

#endif /* MOTORS_H_ */
