/*
 * power.h
 *
 *  Created on: 25.10.2010
 *      Author: AndreR
 */

#ifndef __POWER_H__
#define __POWER_H__

#include "ch.h"
#include "commands.h"
#include "intercom_constants.h"
#include <stdint.h>

typedef void(*PowerUpdatedCallback)();

typedef struct _PowerGlobal
{
	PowerUpdatedCallback cb;

	uint8_t logEnabled;

	SystemPowerLog lastLog;
	SupplyPowerLog supplyLog;
} PowerGlobal;

extern PowerGlobal power;

void PowerInit();
void PowerAddIntercomClient();
void PowerEnable5VSupply(uint8_t enable);
uint8_t PowerIs5VSupplyEnabled();
msg_t PowerTask(void* params);
void PowerSetCallback(PowerUpdatedCallback cb);
void PowerSetLogging(uint8_t enable);

#endif
