/*
 * spi2.h
 *
 *  Created on: 19.01.2014
 *      Author: AndreR
 */

#ifndef SPI2_H_
#define SPI2_H_

#include "util/spi_sync.h"
#include <stdint.h>

#define ACC					0
#define GYR					1

typedef void(*SPI2Callback)(void*);

typedef struct _SPI2Global
{
	SPISync slave[2];

	uint8_t activeSlave;

	SPI2Callback callback;
	void* pUserData;

#ifdef DEBUG
	DMA_Stream_TypeDef* pTxDma;
	DMA_Stream_TypeDef* pRxDma;
	SPI_TypeDef* pSPI;
	DMA_TypeDef* pDMA;
#endif
} SPI2Global;

extern SPI2Global spi2;

void SPI2Init();
msg_t SPI2Task(void* params);

#endif /* SPI2_H_ */
