/*
 * touch.h
 *
 *  Created on: 07.05.2014
 *      Author: AndreR
 */

#ifndef __TOUCH_H__
#define __TOUCH_H__

#include "ch.h"
#include "util/spi_sync.h"

#define TOUCH_DATA_BUF_SIZE 18

typedef struct _Touch
{
	BinarySemaphore touchedSem;
	SPISync spi3;
	uint8_t buf[TOUCH_DATA_BUF_SIZE];

	volatile uint8_t touchPressed;		// clear after reading 1
	volatile uint8_t touchReleased;		// clear after reading 1
	volatile uint8_t touchDown;	// read only by user, indicates valid X and Y

	uint16_t touchX;
	uint16_t touchY;
	uint16_t touchZ1;
	uint16_t touchZ2;
	float touchZ;
} Touch;

extern Touch touch;

void	TouchInit();
msg_t	TouchTask(void* params);

#endif
