/*
 * ctrl_6step.h
 *
 *  Created on: 11.06.2014
 *      Author: AndreR
 */

#ifndef CTRL_6STEP_H_
#define CTRL_6STEP_H_

#include "drive.h"
#include "util/pid.h"

typedef struct _Ctrl6Step
{
	PID pidCurrent;
	PID pidSpeed;

	uint8_t currentOn;
	uint8_t speedOn;
	float setVelocity;
	float setCurrent;
	float setVoltage;

	float curCurrent;
} Ctrl6Step;

extern Ctrl6Step stepFront;
extern Ctrl6Step stepRear;
extern DriveCtrl ctrl6StepFront;
extern DriveCtrl ctrl6StepRear;

void Ctrl6StepEnableCurrent(Ctrl6Step* p6Step, uint8_t enable);
void Ctrl6StepEnableSpeedControl(Ctrl6Step* p6Step, uint8_t enable);
void Ctrl6StepSetFOCPIDParams(Ctrl6Step* p6Step, float p, float i, float d);
void Ctrl6StepSetSpeedPIDParams(Ctrl6Step* p6Step, float p, float i, float d);
void Ctrl6StepSetPhase(Drive* pDrive, uint8_t ph);

#endif /* CTRL_6STEP_H_ */
