/*
 * ctrl_foc.h
 *
 *  Created on: 11.06.2014
 *      Author: AndreR
 */

#ifndef CTRL_FOC_H_
#define CTRL_FOC_H_

#include "drive.h"
#include "util/pid.h"

typedef struct _CtrlFOC
{
	PID pidSpeed;
	PID pid[2];
	uint8_t focOn;
	uint8_t speedOn;
	float setVelocity;
	float setIq;
	float setId;

	float curIq;
	float curId;
} CtrlFOC;

extern CtrlFOC focFront;
extern CtrlFOC focRear;
extern DriveCtrl ctrlFocFront;
extern DriveCtrl ctrlFocRear;

void CtrlFOCEnableFOC(CtrlFOC* pFOC, uint8_t enable);
void CtrlFOCEnableSpeedControl(CtrlFOC* pFOC, uint8_t enable);
void CtrlFOCSetFOCPIDParams(CtrlFOC* pFOC, float p, float i, float d);
void CtrlFOCSetSpeedPIDParams(CtrlFOC* pFOC, float p, float i, float d);

#endif /* CTRL_FOC_H_ */
