/*
 * led.c
 *
 *  Created on: 30.10.2010
 *      Author: AndreR
 */

#include "led.h"

#include "stm32f30x_gpio.h"

#define LED0 (1 << 1)

typedef struct _LEDGlobal
{
	uint8_t state;
} LEDGlobal;

static LEDGlobal led;

void LEDInit()
{
	led.state = 0;

	GPIO_InitTypeDef gpioInit;
	gpioInit.GPIO_Pin = LED0;
	gpioInit.GPIO_Mode = GPIO_Mode_OUT;
	gpioInit.GPIO_OType = GPIO_OType_PP;
	gpioInit.GPIO_Speed = GPIO_Speed_2MHz;
	gpioInit.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOF, &gpioInit);
}

void LEDSet(uint8_t state)
{
	led.state = state;

	if(led.state & LED_MAIN_GREEN)
		GPIOF->BRR = LED0;
	else
		GPIOF->BSRR = LED0;
}

void LEDMustOn(uint8_t on)
{
	LEDSet(led.state | on);
}

void LEDMustOff(uint8_t off)
{
	LEDSet(led.state & ~(off));
}

void LEDToggle(uint8_t toggle)
{
	LEDSet(led.state ^ toggle);
}

uint8_t LEDGetState()
{
	return led.state;
}
