/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "intercom_constants.h"
#include "spi1.h"

Intercom intercom1;

void Intercom1Init(EventManager* pEventManager)
{
	IntercomMedium medium;
	medium.pRxFifo = &spi1.rxFifo;
	medium.pTxFifo = &spi1.txFifo;
	medium.txReady = 0;
	medium.pTxReadyData = 0;
	medium.reachableAddresses = INTERCOM_ADDRESS_MAIN | INTERCOM_ADDRESS_KD | INTERCOM_ADDRESS_MEDIA;

#ifdef MOT_LEFT
	IntercomInit(&intercom1, INTERCOM_ADDRESS_LEFT, 0, pEventManager);
	medium.reachableAddresses |= INTERCOM_ADDRESS_RIGHT;
#else
	IntercomInit(&intercom1, INTERCOM_ADDRESS_RIGHT, 0, pEventManager);
	medium.reachableAddresses |= INTERCOM_ADDRESS_LEFT;
#endif

	spi1.callback = &IntercomRxReady;
	spi1.pCbData = &intercom1;
	IntercomAddMedium(&intercom1, medium);
}
