/*
 * spi1.h
 *
 *  Created on: 15.01.2014
 *      Author: AndreR
 */

#ifndef SPI1_H_
#define SPI1_H_

#include "stm32f30x_spi.h"
#include "stm32f30x_dma.h"
#include "mot_exchange_t.h"
#include "util/fifo_lin.h"
#include "util/event.h"
#include "constants.h"
#include <stdint.h>

typedef void(*SPI1RxCallback)(void*);

#define SPI1_EVENT_QUEUE_SIZE 4

typedef struct _SPI1Global
{
	SPIMot2MainData txData;
	SPIMain2MotData rxData;

	uint8_t fifoDataTx[SPI1_FIFO_SIZE_TX];
	uint8_t fifoDataRx[SPI1_FIFO_SIZE_RX];

	FifoLin txFifo;
	FifoLin rxFifo;

	uint16_t rxSeq;
	uint16_t txSeq;

	Mailbox eventQueue;
	msg_t eventQueueData[SPI1_EVENT_QUEUE_SIZE];

	SPI1RxCallback callback;
	void* pCbData;

	uint32_t lastEventTime;

	uint8_t desynced;

#ifdef DEBUG
	DMA_Channel_TypeDef* pTxDma;
	DMA_Channel_TypeDef* pRxDma;
	SPI_TypeDef* pSPI;
	DMA_TypeDef* pDMA;
#endif
} SPI1Global;

extern SPI1Global spi1;

void SPI1Init();
msg_t SPI1Task(void* params);

#endif /* SPI1_H_ */
