/*
 * event.h
 *
 *  Created on: 06.03.2014
 *      Author: AndreR
 */

#ifndef EVENT_H_
#define EVENT_H_

#include "ch.h"
#include <stdint.h>

typedef void(*EventFunc)(void* pUserData, uint16_t event);
typedef void(*PeriodicFunc)(void* pUserData);
typedef void(*InitFunc)(void* pUserData);

#define EVENT_MAX_CLIENTS 10

typedef struct _EventClient
{
	EventFunc eventFunc;
	PeriodicFunc periodicFunc;
	void* pUserData;

	VirtualTimer periodicTimer;
	systime_t periodicDelay;

	Mailbox* pEventQueue;
	uint32_t clientId;
} EventClient;

typedef struct _EventManager
{
	EventClient clients[EVENT_MAX_CLIENTS];
	uint8_t numClients;
	Mailbox eventQueue;
} EventManager;

void EventManagerInit(EventManager* pManager, int32_t* pMsgBuf, uint16_t bufLen);
msg_t EventManagerTask(void* params);

EventClient* EventClientInit(EventManager* pManager, EventFunc eventFunc, PeriodicFunc periodicFunc, systime_t periodicDelay, void* pUserData);
msg_t EventClientSend(EventClient* pClient, uint32_t event, systime_t timeout);
msg_t EventClientSendI(EventClient* pClient, uint32_t event);

#endif /* EVENT_H_ */
