/*
 * fifo.h
 *
 *  Created on: 03.10.2013
 *      Author: AndreR
 */

#ifndef FIFO_H_
#define FIFO_H_

#include <stdint.h>

typedef struct _Fifo
{
	uint8_t* pFirst;
	uint8_t* pLast;

	uint8_t* volatile pWrite;
	uint8_t* volatile pRead;

	volatile uint32_t bytesFree;
	uint32_t size;
} Fifo;

void 		FifoInit(Fifo* pFifo, uint8_t* pData, uint32_t size);
void 		FifoClear(Fifo* pFifo);
int16_t 	FifoPush(Fifo* pFifo, uint8_t* pData, uint32_t size);
int16_t 	FifoPop(Fifo* pFifo, uint8_t* pDst, uint32_t size);
int16_t 	FifoDrop(Fifo* pFifo, uint32_t size);
uint32_t	FifoGetBytesAvailable(Fifo* pFifo);
int16_t 	FifoFindChar(Fifo* pFifo, uint8_t ch, uint32_t* pBytesToChar);

#endif /* FIFO_H_ */
