/*
 * fifo_delim.h
 *
 *  Created on: 03.10.2013
 *      Author: AndreR
 */

#ifndef FIFO_DELIM_H_
#define FIFO_DELIM_H_

#include "fifo.h"

typedef struct _FifoDelim
{
	Fifo fifo;

	volatile uint32_t numDelimiters;
	uint8_t delimiter;
} FifoDelim;

void FifoDelimInit(FifoDelim* pFifo, uint8_t* pData, uint32_t size, uint8_t delimiter);
void FifoDelimClear(FifoDelim* pFifo);
int16_t FifoDelimPush(FifoDelim* pFifo, uint8_t* pData, uint32_t size);
int16_t FifoDelimPop(FifoDelim* pFifo, uint8_t* pDst, uint32_t size);
int16_t FifoDelimFindNextDelimiter(FifoDelim* pFifo, uint32_t* pSizeToDelim);
int16_t FifoDelimDrop(FifoDelim* pFifo, uint32_t size, uint32_t numDroppedDelims);
int16_t FifoDelimDropToDelim(FifoDelim* pFifo);

#endif /* FIFO_DELIM_H_ */
