/*
 * sys_time.h
 *
 *  Created on: 09.04.2014
 *      Author: AndreR
 */

#ifndef SYS_TIME_H_
#define SYS_TIME_H_

#include "ch.h"

#define NVIC_SYSTICK_CNT ( ( volatile unsigned long * ) 0xE000E018 )

#ifdef STM32F4XX
#define CPU_CLOCK_HZ 168000000UL
#else
#define CPU_CLOCK_HZ 72000000UL
#endif
#define F_CPU_CLOCK_HZ ((float)CPU_CLOCK_HZ)
#define F_TICK_RATE_HZ ((float)CH_FREQUENCY)
#define SYSTICK_CNT_MAX ((CPU_CLOCK_HZ / CH_FREQUENCY) - 1UL)
#define CNT_CLK_1MHZ (CPU_CLOCK_HZ/1000000UL)
#define USEC_PER_TICK (1000000UL/CH_FREQUENCY)

// microsecond precision, integer arithmetic => fast + recommended
static unsigned long SysTimeUSec()
{
	return chTimeNow()*USEC_PER_TICK + (SYSTICK_CNT_MAX-*NVIC_SYSTICK_CNT)/CNT_CLK_1MHZ; // [us]
}

// converts SysTimeUSec to seconds (float)
static inline float SysTime()
{
	return SysTimeUSec()*1e-6f;
}

// maximum precision, uses floating point arithmetic => slow
static inline float SysTimePrec()
{
	return chTimeNow()/F_TICK_RATE_HZ + (SYSTICK_CNT_MAX-*NVIC_SYSTICK_CNT)/F_CPU_CLOCK_HZ;
}

#endif /* SYS_TIME_H_ */
